function f=HSmodel(para,num,Y,X,Z,W,opt)
%num: it selects the output of this function: objective function, moments
%for each t or the moments averages
%
%opt==1 means I use transformed variables; otherwise, I use original
%variables
[T,q]=size(Y);
%
if opt==1
    pbeta=exp(para(1))/(1+exp(para(1)));
    psigma=exp(para(2));
else
    pbeta=para(1);
    psigma=para(2);
end
%
bonds_return=X(:,1);
equity_return=X(:,2);
eta=[ones(length(Y),1)-pbeta.*((1+bonds_return).*(Y.^(-psigma))) ,...
     ones(length(Y),1)-pbeta.*((1+equity_return).*(Y.^(-psigma)))];
for i=1:T
   m_t(i,:)=kron(eta(i,:),Z(i,:));
end
m=mean(m_t)';
obj=m'*W*m;
if num==1
    f=obj;
elseif num==2
    f=m_t;
elseif num==3
    f=m;
end
end
   