%Hansen and Singleton Model (example 2)
clear;
% loading Data 
load data_ex2.txt -ascii;
data=data_ex2(265:end,:);  %265: from january 1982
gc=data(:,8)./100;  % growth rate of consumption
bonds_return=data(:,6)./100;  
equity_return=data(:,2)./100;
%
lagsIV=6;
Y=1+gc(1+lagsIV:end);
X=[bonds_return(1+lagsIV:end) equity_return(1+lagsIV:end)];
Z=[ones(length(Y),1)];  %instrumental variables vector
for i=1:lagsIV
    Z=[Z 1+gc(1+lagsIV-i:end-i)];
end
for i=1:lagsIV
    Z=[Z bonds_return(1+lagsIV-i:end-i)];
end
for i=1:lagsIV
    Z=[Z equity_return(1+lagsIV-i:end-i)];
end
%
para0=[0.97;2]; %initial conditions
para0tr=[log(para0(1)/(1-para0(1)));log(para0(2))]; %transformed variables
cond_ortog=(1+3*lagsIV)*length(para0); % number of ortogonality conditions
n_it=100; %maximum number of iterations
format long;
[paraest,t_sta,V,it,Chi_sta,Pvalue]=gmmest('HSmodel',para0tr,Y,X,Z,n_it,cond_ortog);
disp('Table 2. GMM estimation');
coefficient=paraest;
Std_Error=sqrt(diag(V));
t_statistic=t_sta;
p_value=(1-normcdf(abs(t_sta),0,1)).*2;
names_var={'discount factor (beta)  ';
           'relative risk aversion parameter (sigma)'};
TABLE=table(coefficient,Std_Error,t_statistic,p_value,'RowNames',names_var)
disp('    Testing the Overidentifying Restrictions')   
disp(['    Chi square statistic:            '  num2str(Chi_sta)])
disp(['    p_Value (chi square statistic):  '  num2str(Pvalue)])
disp(['    Critical value (5%):             '  num2str(chi2inv(.95,cond_ortog-length(paraest)))])