function [lfv,Xt1t,xtt,MPtt,xtT] = kf_detrend(param,opt)
%Computing -log of likekihood and predictions using Kalman filter
%If opt==1, then we use untranformed parameters; in other case, we use
%transformed parameters
global Yt Ut
vYt=[Yt';
     Ut'];
T=length(Yt);
if opt==1
    phi=param(1);
    phi2=param(2);
    sigmav=param(3);
    sigmae=param(4);
    sigmaw=param(5);
    alpha0=param(6);
    alpha1=param(7);
    alpha2=param(8);  
    sigmaec=param(9);
    sigmavl=param(10);
else
    sigmav=exp(-param(3))/10;
    sigmae=exp(-param(4))/10;
    sigmaw=exp(-param(5))/10;
    sigmaec=exp(-param(9))/10;
    sigmavl=exp(-param(10))/10;
    d1=param(1)/(1+abs(param(1)));
    d2=param(2)/(1+abs(param(2)));
    phi=d1+d2;
    phi2=-d1*d2;
    alpha0=param(6);
    alpha1=param(7);
    alpha2=param(8);
end
%inicializacin
F=[1  0    0    0  1   0;
   0  phi  phi2 0  0   0;
   0  1    0    0  0   0;
   0  0    1    0  0   0;
   0  0    0    0  1   0;
   0  0    0    0  0   1];
G=[1  1          0         0           0  0;
   0  alpha0     alpha1    alpha2      0  1];

Q=[sigmav^2 0        0 0        0        0;
    0      sigmae^2  0 0        0        0;
    0      0         0 0        0        0;
    0      0         0 0        0        0;
    0      0         0 0        sigmaw^2 0;
    0      0         0 0        0        sigmavl^2];
R=[0       0;
   0       sigmaec^2];
xt1t=zeros(6,1);
xtt=[];Xt1t=[];
MPtt=[];MPt1t=[]; 
Pt1t=eye(6)*100; 
lfv=log(2*pi)*T;  % -log of likelihood function
%
for t=1:T
    ut=vYt(:,t)-G*xt1t;
    Omegat=G*Pt1t*G'+R;
    Omegainvt=inv(Omegat);
    lfv=lfv+0.5*log(det(Omegat))+0.5*ut'*Omegainvt*ut;
    vxtt=xt1t+Pt1t*G'*Omegainvt*ut;
    xtt=[xtt vxtt];
    Ptt=Pt1t-Pt1t*G'*Omegainvt*G*Pt1t;
    MPtt=[MPtt Ptt];
    kt=F*Pt1t*G'*Omegainvt;
    xt1t=F*xt1t+kt*ut; Xt1t=[Xt1t xt1t];
    Pt1t=(F-kt*G)*Pt1t*(F'-G'*kt')+Q; 
    MPt1t=[MPt1t Pt1t];
end
%smoothing
xtT=[];
xtT=[xtt(:,T) xtT];
vxtT=xtt(:,T);
MPtT=[];
MPtT=[MPtt(:,6*(T-1)+1:6*(T-1)+6) MPtT];
PtT=MPtt(:,6*(T-1)+1:6*(T-1)+6);
for t=2:T
    Jt=MPtt(:,6*(T-t)+1:6*(T-t)+6)*F'*inv(MPt1t(:,6*(T-t)+1:6*(T-t)+6));
    vxtT=xtt(:,T-t+1)+Jt*(vxtT-Xt1t(:,T-t+1)); 
    xtT=[vxtT xtT];
    PtT=MPtt(:,6*(T-t)+1:6*(T-t)+6)+Jt*(PtT-MPt1t(:,6*(T-t)+1:6*(T-t)+6))*Jt';
    MPtT=[PtT MPtT];
end