function [V_variance , Mdecomp_v]=decomp_var(Ax,Bx,Cx,V)
% form VX, and BVBX
  V2x = V^2;
  BVBx = Bx*V2x*Bx';
  sigz=V(1,1);
  siga=V(2,2);
  
% set up output matrices
  V_variance = zeros(42,1);
  Mdecomp_v = zeros(42,2);

% calculate k-step ahead forecast error variances

  Akx = eye(3);

  Ss_k = zeros(3,3);
 
  for k = 1:40

    Ss_k = Ss_k + Akx*BVBx*Akx';

    Sd_k = Cx*Ss_k*Cx';

    if k == 1
      V_variance(1) = Sd_k(1,1);
      V_variance(8) = Sd_k(2,2);
      V_variance(15) = Sd_k(3,3);
      V_variance(22) = Sd_k(4,4);
      V_variance(29) = Sd_k(5,5);
      V_variance(36) = Sd_k(6,6);
    end

    if k == 4
      V_variance(2) = Sd_k(1,1);
      V_variance(9) = Sd_k(2,2);
      V_variance(16) = Sd_k(3,3);
      V_variance(23) = Sd_k(4,4);
      V_variance(30) = Sd_k(5,5);
      V_variance(37) = Sd_k(6,6);
    end

    if k == 8
      V_variance(3) = Sd_k(1,1);
      V_variance(10) = Sd_k(2,2);
      V_variance(17) = Sd_k(3,3);
      V_variance(24) = Sd_k(4,4);
      V_variance(31) = Sd_k(5,5);
      V_variance(38) = Sd_k(6,6);
    end

    if k == 12
      V_variance(4) = Sd_k(1,1);
      V_variance(11) = Sd_k(2,2);
      V_variance(18) = Sd_k(3,3);
      V_variance(25) = Sd_k(4,4);
      V_variance(32) = Sd_k(5,5);
      V_variance(39) = Sd_k(6,6);
    end

    if k == 20
      V_variance(5) = Sd_k(1,1);
      V_variance(12) = Sd_k(2,2);
      V_variance(19) = Sd_k(3,3);
      V_variance(26) = Sd_k(4,4);
      V_variance(33) = Sd_k(5,5);
      V_variance(40) = Sd_k(6,6);
    end

    if k == 40
      V_variance(6) = Sd_k(1,1);
      V_variance(13) = Sd_k(2,2);
      V_variance(20) = Sd_k(3,3);
      V_variance(27) = Sd_k(4,4);
      V_variance(34) = Sd_k(5,5);
      V_variance(41) = Sd_k(6,6);
    end

    Akx = Akx*Ax;

  end    

  bigsigs1 = inv(eye(9)-kron(Ax,Ax))*BVBx(:);

  bigsigs = reshape(bigsigs1,3,3);

  bigsigd = Cx*bigsigs*Cx';

  V_variance(7) = bigsigd(1,1);
  V_variance(14) = bigsigd(2,2);
  V_variance(21) = bigsigd(3,3);
  V_variance(28) = bigsigd(4,4);
  V_variance(35) = bigsigd(5,5);
  V_variance(42) = bigsigd(6,6);
 
% calculate fractions due to supply shocks

  V2x = diag([sigz^2 0]);

  BVBx = Bx*V2x*Bx';

  Akx = eye(3);

  Ss_k = zeros(3,3);

  for k = 1:40

    Ss_k = Ss_k + Akx*BVBx*Akx';

    Sd_k = Cx*Ss_k*Cx';

    if k == 1
      Mdecomp_v(1,1) = Sd_k(1,1)/V_variance(1);
      Mdecomp_v(8,1) = Sd_k(2,2)/V_variance(8);
      Mdecomp_v(15,1) = Sd_k(3,3)/V_variance(15);
      Mdecomp_v(22,1) = Sd_k(4,4)/V_variance(22);
      Mdecomp_v(29,1) = Sd_k(5,5)/V_variance(29);
      Mdecomp_v(36,1) = Sd_k(6,6)/V_variance(36);
    end

    if k == 4
      Mdecomp_v(2,1) = Sd_k(1,1)/V_variance(2);
      Mdecomp_v(9,1) = Sd_k(2,2)/V_variance(9);
      Mdecomp_v(16,1) = Sd_k(3,3)/V_variance(16);
      Mdecomp_v(23,1) = Sd_k(4,4)/V_variance(23);
      Mdecomp_v(30,1) = Sd_k(5,5)/V_variance(30);
      Mdecomp_v(37,1) = Sd_k(6,6)/V_variance(37);
    end

    if k == 8
      Mdecomp_v(3,1) = Sd_k(1,1)/V_variance(3);
      Mdecomp_v(10,1) = Sd_k(2,2)/V_variance(10);
      Mdecomp_v(17,1) = Sd_k(3,3)/V_variance(17);
      Mdecomp_v(24,1) = Sd_k(4,4)/V_variance(24);
      Mdecomp_v(31,1) = Sd_k(5,5)/V_variance(31);
      Mdecomp_v(38,1) = Sd_k(6,6)/V_variance(38);
    end

   if k == 12
      Mdecomp_v(4,1) = Sd_k(1,1)/V_variance(4);
      Mdecomp_v(11,1) = Sd_k(2,2)/V_variance(11);
      Mdecomp_v(18,1) = Sd_k(3,3)/V_variance(18);
      Mdecomp_v(25,1) = Sd_k(4,4)/V_variance(25);
      Mdecomp_v(32,1) = Sd_k(5,5)/V_variance(32);
      Mdecomp_v(39,1) = Sd_k(6,6)/V_variance(39);
    end

    if k == 20
      Mdecomp_v(5,1) = Sd_k(1,1)/V_variance(5);
      Mdecomp_v(12,1) = Sd_k(2,2)/V_variance(12);
      Mdecomp_v(19,1) = Sd_k(3,3)/V_variance(19);
      Mdecomp_v(26,1) = Sd_k(4,4)/V_variance(26);
      Mdecomp_v(33,1) = Sd_k(5,5)/V_variance(33);
      Mdecomp_v(40,1) = Sd_k(6,6)/V_variance(40);
    end

    if k == 40
      Mdecomp_v(6,1) = Sd_k(1,1)/V_variance(6);
      Mdecomp_v(13,1) = Sd_k(2,2)/V_variance(13);
      Mdecomp_v(20,1) = Sd_k(3,3)/V_variance(20);
      Mdecomp_v(27,1) = Sd_k(4,4)/V_variance(27);
      Mdecomp_v(34,1) = Sd_k(5,5)/V_variance(34);
      Mdecomp_v(41,1) = Sd_k(6,6)/V_variance(41);
    end

    Akx = Akx*Ax;

  end    

  bigsigs1 = inv(eye(9)-kron(Ax,Ax))*BVBx(:);

  bigsigs = reshape(bigsigs1,3,3);

  bigsigd = Cx*bigsigs*Cx';

  Mdecomp_v(7,1) = bigsigd(1,1)/V_variance(7);
  Mdecomp_v(14,1) = bigsigd(2,2)/V_variance(14);
  Mdecomp_v(21,1) = bigsigd(3,3)/V_variance(21);
  Mdecomp_v(28,1) = bigsigd(4,4)/V_variance(28);
  Mdecomp_v(35,1) = bigsigd(5,5)/V_variance(35);
  Mdecomp_v(42,1) = bigsigd(6,6)/V_variance(42);
  
% calculate fractions due to demand shocks

  V2x = diag([0 siga^2]);

  BVBx = Bx*V2x*Bx';

  Akx = eye(3);

  Ss_k = zeros(3,3);

  for k = 1:40

    Ss_k = Ss_k + Akx*BVBx*Akx';

    Sd_k = Cx*Ss_k*Cx';

    if k == 1
      Mdecomp_v(1,2) = Sd_k(1,1)/V_variance(1);
      Mdecomp_v(8,2) = Sd_k(2,2)/V_variance(8);
      Mdecomp_v(15,2) = Sd_k(3,3)/V_variance(15);
      Mdecomp_v(22,2) = Sd_k(4,4)/V_variance(22);
      Mdecomp_v(29,2) = Sd_k(5,5)/V_variance(29);
      Mdecomp_v(36,2) = Sd_k(6,6)/V_variance(36);
    end

    if k == 4
      Mdecomp_v(2,2) = Sd_k(1,1)/V_variance(2);
      Mdecomp_v(9,2) = Sd_k(2,2)/V_variance(9);
      Mdecomp_v(16,2) = Sd_k(3,3)/V_variance(16);
      Mdecomp_v(23,2) = Sd_k(4,4)/V_variance(23);
      Mdecomp_v(30,2) = Sd_k(5,5)/V_variance(30);
      Mdecomp_v(37,2) = Sd_k(6,6)/V_variance(37);
    end

    if k == 8
      Mdecomp_v(3,2) = Sd_k(1,1)/V_variance(3);
      Mdecomp_v(10,2) = Sd_k(2,2)/V_variance(10);
      Mdecomp_v(17,2) = Sd_k(3,3)/V_variance(17);
      Mdecomp_v(24,2) = Sd_k(4,4)/V_variance(24);
      Mdecomp_v(31,2) = Sd_k(5,5)/V_variance(31);
      Mdecomp_v(38,2) = Sd_k(6,6)/V_variance(38);
    end

   if k == 12
      Mdecomp_v(4,2) = Sd_k(1,1)/V_variance(4);
      Mdecomp_v(11,2) = Sd_k(2,2)/V_variance(11);
      Mdecomp_v(18,2) = Sd_k(3,3)/V_variance(18);
      Mdecomp_v(25,2) = Sd_k(4,4)/V_variance(25);
      Mdecomp_v(32,2) = Sd_k(5,5)/V_variance(32);
      Mdecomp_v(39,2) = Sd_k(6,6)/V_variance(39);
    end

    if k == 20
      Mdecomp_v(5,2) = Sd_k(1,1)/V_variance(5);
      Mdecomp_v(12,2) = Sd_k(2,2)/V_variance(12);
      Mdecomp_v(19,2) = Sd_k(3,3)/V_variance(19);
      Mdecomp_v(26,2) = Sd_k(4,4)/V_variance(26);
      Mdecomp_v(33,2) = Sd_k(5,5)/V_variance(33);
      Mdecomp_v(40,2) = Sd_k(6,6)/V_variance(40);
    end

    if k == 40
      Mdecomp_v(6,2) = Sd_k(1,1)/V_variance(6);
      Mdecomp_v(13,2) = Sd_k(2,2)/V_variance(13);
      Mdecomp_v(20,2) = Sd_k(3,3)/V_variance(20);
      Mdecomp_v(27,2) = Sd_k(4,4)/V_variance(27);
      Mdecomp_v(34,2) = Sd_k(5,5)/V_variance(34);
      Mdecomp_v(41,2) = Sd_k(6,6)/V_variance(41);
    end

    Akx = Akx*Ax;

  end    

  bigsigs1 = inv(eye(9)-kron(Ax,Ax))*BVBx(:);

  bigsigs = reshape(bigsigs1,3,3);

  bigsigd = Cx*bigsigs*Cx';

  Mdecomp_v(7,2) = bigsigd(1,1)/V_variance(7);
  Mdecomp_v(14,2) = bigsigd(2,2)/V_variance(14);
  Mdecomp_v(21,2) = bigsigd(3,3)/V_variance(21);
  Mdecomp_v(28,2) = bigsigd(4,4)/V_variance(28);
  Mdecomp_v(35,2) = bigsigd(5,5)/V_variance(35);
  Mdecomp_v(42,2) = bigsigd(6,6)/V_variance(42);

% convert to percentages

  V_variance = 100*V_variance;

  Mdecomp_v = 100*Mdecomp_v;