%Hansen and Singleton Model (example 1)
clear;
% loading Data 
load data.prn -ascii;
pcepi=data(:,3); %
gc=log(pcepi(13:end)./pcepi(1:end-12));
tb3ms=data(13:end,1)./100;
gs10=data(13:end,2)./100;
%
lagsIV=3;
Y=1+gc(1+lagsIV:end);
X=[tb3ms(1+lagsIV:end) gs10(1+lagsIV:end)];
Z=[ones(length(Y),1)];  %instrumental variables vector
for i=1:lagsIV
    Z=[Z 1+gc(1+lagsIV-i:end-i)];
end
for i=1:lagsIV
    Z=[Z tb3ms(1+lagsIV-i:end-i)];
end
for i=1:lagsIV
    Z=[Z gs10(1+lagsIV-i:end-i)];
end
para0=[0.992;2];  %initial conditions
para0tr=[log(para0(1)/(1-para0(1)));para0(2)];  %transformed variables
cond_ortog=(1+3*lagsIV)*length(para0);  % number of ortogonality conditions
n_it=100;  %maximum number of iterations
format long;
[paraest,t_sta,V,it,Chi_sta,Pvalue]=gmmest('HSmodel',para0tr,Y,X,Z,n_it,cond_ortog);
disp('Table 1. GMM Estimation');
coefficient=paraest;
Std_Error=sqrt(diag(V));
t_statistic=t_sta;
p_value=(1-normcdf(abs(t_sta),0,1)).*2;
names_var={'discount factor (beta)';
           'relative risk aversion parameter (sigma)'};
TABLE=table(coefficient,Std_Error,t_statistic,p_value,'RowNames',names_var)
disp('    Testing the Overidentifying Restrictions')   
disp(['    Chi square statistic:            '  num2str(Chi_sta)])
disp(['    p_Value (chi square statistic):  '  num2str(Pvalue)])
disp(['    Critical value (5%):             '  num2str(chi2inv(.95,cond_ortog-length(paraest)))])